#[doc = "Register `ROM_END` reader"]
pub struct R(crate::R<ROM_END_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<ROM_END_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<ROM_END_SPEC>> for R {
    fn from(reader: crate::R<ROM_END_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `ROM_END` writer"]
pub struct W(crate::W<ROM_END_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<ROM_END_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<ROM_END_SPEC>> for W {
    fn from(writer: crate::W<ROM_END_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `VALUE` reader - End marker in peripheral list"]
pub struct VALUE_R(crate::FieldReader<u32, u32>);
impl VALUE_R {
    pub(crate) fn new(bits: u32) -> Self {
        VALUE_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for VALUE_R {
    type Target = crate::FieldReader<u32, u32>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl R {
    #[doc = "Bits 0:31 - End marker in peripheral list"]
    #[inline(always)]
    pub fn value(&self) -> VALUE_R {
        VALUE_R::new((self.bits & 0xffff_ffff) as u32)
    }
}
impl W {
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "CM0 CoreSight ROM Table End Marker\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rom_end](index.html) module"]
pub struct ROM_END_SPEC;
impl crate::RegisterSpec for ROM_END_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [rom_end::R](R) reader structure"]
impl crate::Readable for ROM_END_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [rom_end::W](W) writer structure"]
impl crate::Writable for ROM_END_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets ROM_END to value 0"]
impl crate::Resettable for ROM_END_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
